library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_unsigned.all;  
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

entity clkdiv is
generic (D : natural := 27);
port( 
    mclk : in STD_LOGIC; 
    clr : in STD_LOGIC; 
    clk_1hz : out STD_LOGIC 
   ); 
end clkdiv;

architecture Behavioral of clkdiv is 
    signal q: STD_LOGIC_VECTOR(D-1 downto 0); 
begin 
    -- clock divider 
    process(mclk, clr) 
    begin 
    if clr = '1' then 
        q <= (others => '0'); 
    elsif rising_edge(mclk) then --similar to (mclk'event and mclk = '1')
        q <= q + 1; 
    end if; 
    end process; 
    clk_1hz <= q(D-1);  -- clk is about 1hz
end Behavioral;

