----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 15.11.2016 15:23:33
-- Design Name: 
-- Module Name: traffic_moore_tb - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity traffic_moore_delayed_tb is
--  Port ( );
generic (N: natural := 3);
end traffic_moore_delayed_tb;

architecture Behavioral of traffic_moore_delayed_tb is

    component traffic_moore_delayed is
    generic (N: natural);    
    port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           led : out  STD_LOGIC_VECTOR (N-1 downto 0));
    end component;

--Inputs
   signal reset : std_logic := '0';
   signal clk : std_logic := '0';

 	--Outputs
   signal led : std_logic_vector(N-1 downto 0);

   -- Clock period definitions
   constant clk_period : time := 8 ns;
 
begin
 
	-- Instantiate the Unit Under Test (UUT)
   uut: entity work.traffic_moore_delayed(Behavioral) 
   port map (
          clk => clk,
          reset  => reset,
          led  => led
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- insert stimulus here 
      -- hold reset state for 100 ns.
      reset <= '1';
	  wait for 100 ns;	
      reset <= '0';
      wait for clk_period*100;

      wait;
   end process;

end;
 
