library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity traffic_moore_delayed_top is
generic (N: natural := 3); 
  Port ( mclk : in  STD_LOGIC;
         reset : in  STD_LOGIC;
         led : out  STD_LOGIC_VECTOR(2 downto 0);
         dialight : out STD_LOGIC_VECTOR(2 downto 0));
end traffic_moore_delayed_top;

architecture Behavioral of traffic_moore_delayed_top is

    component clkdiv
    generic (D : natural :=27); --leoszts rtke
    Port ( mclk : in  STD_LOGIC;
           clr : in  STD_LOGIC;
           clk_1hz : out  STD_LOGIC);
    end component;
    
    component traffic_moore_delayed
    generic(N: natural :=3 ); --ledek szma
    port(
        clk : in std_logic;
        reset : in std_logic;
        led : out std_logic_vector(N-1 downto 0));
    end component;

	signal int_clk_1hz : std_logic := '0';
	signal led_sig: STD_LOGIC_VECTOR(N-1 downto 0) := (others => '0');
begin

	u1: entity work.clkdiv(Behavioral)
	generic map (D => 27)
	port map (mclk => mclk, clr => reset, clk_1hz => int_clk_1hz);

	u2: entity work.traffic_moore_delayed(Behavioral)
	generic map (N => 3)
	port map (clk => int_clk_1hz, reset => reset, led => led_sig);
		
	dialight <= led_sig;
	led <= led_sig;
end Behavioral;

